// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package configservice

import (
	"context"

	"github.com/aws/aws-sdk-go-v2-0.24/aws"
	"github.com/aws/aws-sdk-go-v2-0.24/internal/awsutil"
)

type DescribeOrganizationConformancePackStatusesInput struct {
	_ struct{} `type:"structure"`

	// The maximum number of OrganizationConformancePackStatuses returned on each
	// page. If you do no specify a number, AWS Config uses the default. The default
	// is 100.
	Limit *int64 `type:"integer"`

	// The nextToken string returned on a previous page that you use to get the
	// next page of results in a paginated response.
	NextToken *string `type:"string"`

	// The names of organization conformance packs for which you want status details.
	// If you do not specify any names, AWS Config returns details for all your
	// organization conformance packs.
	OrganizationConformancePackNames []string `type:"list"`
}

// String returns the string representation
func (s DescribeOrganizationConformancePackStatusesInput) String() string {
	return awsutil.Prettify(s)
}

type DescribeOrganizationConformancePackStatusesOutput struct {
	_ struct{} `type:"structure"`

	// The nextToken string returned on a previous page that you use to get the
	// next page of results in a paginated response.
	NextToken *string `type:"string"`

	// A list of OrganizationConformancePackStatus objects.
	OrganizationConformancePackStatuses []OrganizationConformancePackStatus `type:"list"`
}

// String returns the string representation
func (s DescribeOrganizationConformancePackStatusesOutput) String() string {
	return awsutil.Prettify(s)
}

const opDescribeOrganizationConformancePackStatuses = "DescribeOrganizationConformancePackStatuses"

// DescribeOrganizationConformancePackStatusesRequest returns a request value for making API operation for
// AWS Config.
//
// Provides organization conformance pack deployment status for an organization.
//
// The status is not considered successful until organization conformance pack
// is successfully deployed in all the member accounts with an exception of
// excluded accounts.
//
// When you specify the limit and the next token, you receive a paginated response.
// Limit and next token are not applicable if you specify organization conformance
// pack names. They are only applicable, when you request all the organization
// conformance packs.
//
// Only a master account can call this API.
//
//    // Example sending a request using DescribeOrganizationConformancePackStatusesRequest.
//    req := client.DescribeOrganizationConformancePackStatusesRequest(params)
//    resp, err := req.Send(context.TODO())
//    if err == nil {
//        fmt.Println(resp)
//    }
//
// Please also see https://docs.aws.amazon.com/goto/WebAPI/config-2014-11-12/DescribeOrganizationConformancePackStatuses
func (c *Client) DescribeOrganizationConformancePackStatusesRequest(input *DescribeOrganizationConformancePackStatusesInput) DescribeOrganizationConformancePackStatusesRequest {
	op := &aws.Operation{
		Name:       opDescribeOrganizationConformancePackStatuses,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &DescribeOrganizationConformancePackStatusesInput{}
	}

	req := c.newRequest(op, input, &DescribeOrganizationConformancePackStatusesOutput{})

	return DescribeOrganizationConformancePackStatusesRequest{Request: req, Input: input, Copy: c.DescribeOrganizationConformancePackStatusesRequest}
}

// DescribeOrganizationConformancePackStatusesRequest is the request type for the
// DescribeOrganizationConformancePackStatuses API operation.
type DescribeOrganizationConformancePackStatusesRequest struct {
	*aws.Request
	Input *DescribeOrganizationConformancePackStatusesInput
	Copy  func(*DescribeOrganizationConformancePackStatusesInput) DescribeOrganizationConformancePackStatusesRequest
}

// Send marshals and sends the DescribeOrganizationConformancePackStatuses API request.
func (r DescribeOrganizationConformancePackStatusesRequest) Send(ctx context.Context) (*DescribeOrganizationConformancePackStatusesResponse, error) {
	r.Request.SetContext(ctx)
	err := r.Request.Send()
	if err != nil {
		return nil, err
	}

	resp := &DescribeOrganizationConformancePackStatusesResponse{
		DescribeOrganizationConformancePackStatusesOutput: r.Request.Data.(*DescribeOrganizationConformancePackStatusesOutput),
		response: &aws.Response{Request: r.Request},
	}

	return resp, nil
}

// DescribeOrganizationConformancePackStatusesResponse is the response type for the
// DescribeOrganizationConformancePackStatuses API operation.
type DescribeOrganizationConformancePackStatusesResponse struct {
	*DescribeOrganizationConformancePackStatusesOutput

	response *aws.Response
}

// SDKResponseMetdata returns the response metadata for the
// DescribeOrganizationConformancePackStatuses request.
func (r *DescribeOrganizationConformancePackStatusesResponse) SDKResponseMetdata() *aws.Response {
	return r.response
}
