// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package connect

import (
	"context"

	"github.com/aws/aws-sdk-go-v2-0.24/aws"
	"github.com/aws/aws-sdk-go-v2-0.24/internal/awsutil"
	"github.com/aws/aws-sdk-go-v2-0.24/private/protocol"
)

type ResumeContactRecordingInput struct {
	_ struct{} `type:"structure"`

	// The identifier of the contact.
	//
	// ContactId is a required field
	ContactId *string `min:"1" type:"string" required:"true"`

	// The identifier of the contact. This is the identifier of the contact associated
	// with the first interaction with the contact center.
	//
	// InitialContactId is a required field
	InitialContactId *string `min:"1" type:"string" required:"true"`

	// The identifier of the Amazon Connect instance.
	//
	// InstanceId is a required field
	InstanceId *string `min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s ResumeContactRecordingInput) String() string {
	return awsutil.Prettify(s)
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *ResumeContactRecordingInput) Validate() error {
	invalidParams := aws.ErrInvalidParams{Context: "ResumeContactRecordingInput"}

	if s.ContactId == nil {
		invalidParams.Add(aws.NewErrParamRequired("ContactId"))
	}
	if s.ContactId != nil && len(*s.ContactId) < 1 {
		invalidParams.Add(aws.NewErrParamMinLen("ContactId", 1))
	}

	if s.InitialContactId == nil {
		invalidParams.Add(aws.NewErrParamRequired("InitialContactId"))
	}
	if s.InitialContactId != nil && len(*s.InitialContactId) < 1 {
		invalidParams.Add(aws.NewErrParamMinLen("InitialContactId", 1))
	}

	if s.InstanceId == nil {
		invalidParams.Add(aws.NewErrParamRequired("InstanceId"))
	}
	if s.InstanceId != nil && len(*s.InstanceId) < 1 {
		invalidParams.Add(aws.NewErrParamMinLen("InstanceId", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// MarshalFields encodes the AWS API shape using the passed in protocol encoder.
func (s ResumeContactRecordingInput) MarshalFields(e protocol.FieldEncoder) error {
	e.SetValue(protocol.HeaderTarget, "Content-Type", protocol.StringValue("application/json"), protocol.Metadata{})

	if s.ContactId != nil {
		v := *s.ContactId

		metadata := protocol.Metadata{}
		e.SetValue(protocol.BodyTarget, "ContactId", protocol.QuotedValue{ValueMarshaler: protocol.StringValue(v)}, metadata)
	}
	if s.InitialContactId != nil {
		v := *s.InitialContactId

		metadata := protocol.Metadata{}
		e.SetValue(protocol.BodyTarget, "InitialContactId", protocol.QuotedValue{ValueMarshaler: protocol.StringValue(v)}, metadata)
	}
	if s.InstanceId != nil {
		v := *s.InstanceId

		metadata := protocol.Metadata{}
		e.SetValue(protocol.BodyTarget, "InstanceId", protocol.QuotedValue{ValueMarshaler: protocol.StringValue(v)}, metadata)
	}
	return nil
}

type ResumeContactRecordingOutput struct {
	_ struct{} `type:"structure"`
}

// String returns the string representation
func (s ResumeContactRecordingOutput) String() string {
	return awsutil.Prettify(s)
}

// MarshalFields encodes the AWS API shape using the passed in protocol encoder.
func (s ResumeContactRecordingOutput) MarshalFields(e protocol.FieldEncoder) error {
	return nil
}

const opResumeContactRecording = "ResumeContactRecording"

// ResumeContactRecordingRequest returns a request value for making API operation for
// Amazon Connect Service.
//
// When a contact is being recorded, and the recording has been suspended using
// SuspendContactRecording, this API resumes recording the call.
//
// Only voice recordings are supported at this time.
//
//    // Example sending a request using ResumeContactRecordingRequest.
//    req := client.ResumeContactRecordingRequest(params)
//    resp, err := req.Send(context.TODO())
//    if err == nil {
//        fmt.Println(resp)
//    }
//
// Please also see https://docs.aws.amazon.com/goto/WebAPI/connect-2017-08-08/ResumeContactRecording
func (c *Client) ResumeContactRecordingRequest(input *ResumeContactRecordingInput) ResumeContactRecordingRequest {
	op := &aws.Operation{
		Name:       opResumeContactRecording,
		HTTPMethod: "POST",
		HTTPPath:   "/contact/resume-recording",
	}

	if input == nil {
		input = &ResumeContactRecordingInput{}
	}

	req := c.newRequest(op, input, &ResumeContactRecordingOutput{})

	return ResumeContactRecordingRequest{Request: req, Input: input, Copy: c.ResumeContactRecordingRequest}
}

// ResumeContactRecordingRequest is the request type for the
// ResumeContactRecording API operation.
type ResumeContactRecordingRequest struct {
	*aws.Request
	Input *ResumeContactRecordingInput
	Copy  func(*ResumeContactRecordingInput) ResumeContactRecordingRequest
}

// Send marshals and sends the ResumeContactRecording API request.
func (r ResumeContactRecordingRequest) Send(ctx context.Context) (*ResumeContactRecordingResponse, error) {
	r.Request.SetContext(ctx)
	err := r.Request.Send()
	if err != nil {
		return nil, err
	}

	resp := &ResumeContactRecordingResponse{
		ResumeContactRecordingOutput: r.Request.Data.(*ResumeContactRecordingOutput),
		response:                     &aws.Response{Request: r.Request},
	}

	return resp, nil
}

// ResumeContactRecordingResponse is the response type for the
// ResumeContactRecording API operation.
type ResumeContactRecordingResponse struct {
	*ResumeContactRecordingOutput

	response *aws.Response
}

// SDKResponseMetdata returns the response metadata for the
// ResumeContactRecording request.
func (r *ResumeContactRecordingResponse) SDKResponseMetdata() *aws.Response {
	return r.response
}
