// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package ec2instanceconnectiface provides an interface to enable mocking the AWS EC2 Instance Connect service client
// for testing your code.
//
// It is important to note that this interface will have breaking changes
// when the service model is updated and adds new API operations, paginators,
// and waiters.
package ec2instanceconnectiface

import (
	"github.com/aws/aws-sdk-go-v2-0.24/service/ec2instanceconnect"
)

// ClientAPI provides an interface to enable mocking the
// ec2instanceconnect.Client methods. This make unit testing your code that
// calls out to the SDK's service client's calls easier.
//
// The best way to use this interface is so the SDK's service client's calls
// can be stubbed out for unit testing your code with the SDK without needing
// to inject custom request handlers into the SDK's request pipeline.
//
//    // myFunc uses an SDK service client to make a request to
//    // EC2 Instance Connect.
//    func myFunc(svc ec2instanceconnectiface.ClientAPI) bool {
//        // Make svc.SendSSHPublicKey request
//    }
//
//    func main() {
//        cfg, err := external.LoadDefaultAWSConfig()
//        if err != nil {
//            panic("failed to load config, " + err.Error())
//        }
//
//        svc := ec2instanceconnect.New(cfg)
//
//        myFunc(svc)
//    }
//
// In your _test.go file:
//
//    // Define a mock struct to be used in your unit tests of myFunc.
//    type mockClientClient struct {
//        ec2instanceconnectiface.ClientPI
//    }
//    func (m *mockClientClient) SendSSHPublicKey(input *ec2instanceconnect.SendSSHPublicKeyInput) (*ec2instanceconnect.SendSSHPublicKeyOutput, error) {
//        // mock response/functionality
//    }
//
//    func TestMyFunc(t *testing.T) {
//        // Setup Test
//        mockSvc := &mockClientClient{}
//
//        myfunc(mockSvc)
//
//        // Verify myFunc's functionality
//    }
//
// It is important to note that this interface will have breaking changes
// when the service model is updated and adds new API operations, paginators,
// and waiters. Its suggested to use the pattern above for testing, or using
// tooling to generate mocks to satisfy the interfaces.
type ClientAPI interface {
	SendSSHPublicKeyRequest(*ec2instanceconnect.SendSSHPublicKeyInput) ec2instanceconnect.SendSSHPublicKeyRequest
}

var _ ClientAPI = (*ec2instanceconnect.Client)(nil)
