// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package marketplacecommerceanalyticsiface provides an interface to enable mocking the AWS Marketplace Commerce Analytics service client
// for testing your code.
//
// It is important to note that this interface will have breaking changes
// when the service model is updated and adds new API operations, paginators,
// and waiters.
package marketplacecommerceanalyticsiface

import (
	"github.com/aws/aws-sdk-go-v2-0.24/service/marketplacecommerceanalytics"
)

// ClientAPI provides an interface to enable mocking the
// marketplacecommerceanalytics.Client methods. This make unit testing your code that
// calls out to the SDK's service client's calls easier.
//
// The best way to use this interface is so the SDK's service client's calls
// can be stubbed out for unit testing your code with the SDK without needing
// to inject custom request handlers into the SDK's request pipeline.
//
//    // myFunc uses an SDK service client to make a request to
//    // AWS Marketplace Commerce Analytics.
//    func myFunc(svc marketplacecommerceanalyticsiface.ClientAPI) bool {
//        // Make svc.GenerateDataSet request
//    }
//
//    func main() {
//        cfg, err := external.LoadDefaultAWSConfig()
//        if err != nil {
//            panic("failed to load config, " + err.Error())
//        }
//
//        svc := marketplacecommerceanalytics.New(cfg)
//
//        myFunc(svc)
//    }
//
// In your _test.go file:
//
//    // Define a mock struct to be used in your unit tests of myFunc.
//    type mockClientClient struct {
//        marketplacecommerceanalyticsiface.ClientPI
//    }
//    func (m *mockClientClient) GenerateDataSet(input *marketplacecommerceanalytics.GenerateDataSetInput) (*marketplacecommerceanalytics.GenerateDataSetOutput, error) {
//        // mock response/functionality
//    }
//
//    func TestMyFunc(t *testing.T) {
//        // Setup Test
//        mockSvc := &mockClientClient{}
//
//        myfunc(mockSvc)
//
//        // Verify myFunc's functionality
//    }
//
// It is important to note that this interface will have breaking changes
// when the service model is updated and adds new API operations, paginators,
// and waiters. Its suggested to use the pattern above for testing, or using
// tooling to generate mocks to satisfy the interfaces.
type ClientAPI interface {
	GenerateDataSetRequest(*marketplacecommerceanalytics.GenerateDataSetInput) marketplacecommerceanalytics.GenerateDataSetRequest

	StartSupportDataExportRequest(*marketplacecommerceanalytics.StartSupportDataExportInput) marketplacecommerceanalytics.StartSupportDataExportRequest
}

var _ ClientAPI = (*marketplacecommerceanalytics.Client)(nil)
