// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package medialive

import (
	"context"

	"github.com/aws/aws-sdk-go-v2-0.24/aws"
	"github.com/aws/aws-sdk-go-v2-0.24/internal/awsutil"
	"github.com/aws/aws-sdk-go-v2-0.24/private/protocol"
)

type DescribeMultiplexProgramInput struct {
	_ struct{} `type:"structure"`

	// MultiplexId is a required field
	MultiplexId *string `location:"uri" locationName:"multiplexId" type:"string" required:"true"`

	// ProgramName is a required field
	ProgramName *string `location:"uri" locationName:"programName" type:"string" required:"true"`
}

// String returns the string representation
func (s DescribeMultiplexProgramInput) String() string {
	return awsutil.Prettify(s)
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *DescribeMultiplexProgramInput) Validate() error {
	invalidParams := aws.ErrInvalidParams{Context: "DescribeMultiplexProgramInput"}

	if s.MultiplexId == nil {
		invalidParams.Add(aws.NewErrParamRequired("MultiplexId"))
	}

	if s.ProgramName == nil {
		invalidParams.Add(aws.NewErrParamRequired("ProgramName"))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// MarshalFields encodes the AWS API shape using the passed in protocol encoder.
func (s DescribeMultiplexProgramInput) MarshalFields(e protocol.FieldEncoder) error {
	e.SetValue(protocol.HeaderTarget, "Content-Type", protocol.StringValue("application/json"), protocol.Metadata{})

	if s.MultiplexId != nil {
		v := *s.MultiplexId

		metadata := protocol.Metadata{}
		e.SetValue(protocol.PathTarget, "multiplexId", protocol.QuotedValue{ValueMarshaler: protocol.StringValue(v)}, metadata)
	}
	if s.ProgramName != nil {
		v := *s.ProgramName

		metadata := protocol.Metadata{}
		e.SetValue(protocol.PathTarget, "programName", protocol.QuotedValue{ValueMarshaler: protocol.StringValue(v)}, metadata)
	}
	return nil
}

type DescribeMultiplexProgramOutput struct {
	_ struct{} `type:"structure"`

	ChannelId *string `locationName:"channelId" type:"string"`

	// Multiplex Program settings configuration.
	MultiplexProgramSettings *MultiplexProgramSettings `locationName:"multiplexProgramSettings" type:"structure"`

	// Packet identifiers map for a given Multiplex program.
	PacketIdentifiersMap *MultiplexProgramPacketIdentifiersMap `locationName:"packetIdentifiersMap" type:"structure"`

	ProgramName *string `locationName:"programName" type:"string"`
}

// String returns the string representation
func (s DescribeMultiplexProgramOutput) String() string {
	return awsutil.Prettify(s)
}

// MarshalFields encodes the AWS API shape using the passed in protocol encoder.
func (s DescribeMultiplexProgramOutput) MarshalFields(e protocol.FieldEncoder) error {
	if s.ChannelId != nil {
		v := *s.ChannelId

		metadata := protocol.Metadata{}
		e.SetValue(protocol.BodyTarget, "channelId", protocol.QuotedValue{ValueMarshaler: protocol.StringValue(v)}, metadata)
	}
	if s.MultiplexProgramSettings != nil {
		v := s.MultiplexProgramSettings

		metadata := protocol.Metadata{}
		e.SetFields(protocol.BodyTarget, "multiplexProgramSettings", v, metadata)
	}
	if s.PacketIdentifiersMap != nil {
		v := s.PacketIdentifiersMap

		metadata := protocol.Metadata{}
		e.SetFields(protocol.BodyTarget, "packetIdentifiersMap", v, metadata)
	}
	if s.ProgramName != nil {
		v := *s.ProgramName

		metadata := protocol.Metadata{}
		e.SetValue(protocol.BodyTarget, "programName", protocol.QuotedValue{ValueMarshaler: protocol.StringValue(v)}, metadata)
	}
	return nil
}

const opDescribeMultiplexProgram = "DescribeMultiplexProgram"

// DescribeMultiplexProgramRequest returns a request value for making API operation for
// AWS Elemental MediaLive.
//
// Get the details for a program in a multiplex.
//
//    // Example sending a request using DescribeMultiplexProgramRequest.
//    req := client.DescribeMultiplexProgramRequest(params)
//    resp, err := req.Send(context.TODO())
//    if err == nil {
//        fmt.Println(resp)
//    }
//
// Please also see https://docs.aws.amazon.com/goto/WebAPI/medialive-2017-10-14/DescribeMultiplexProgram
func (c *Client) DescribeMultiplexProgramRequest(input *DescribeMultiplexProgramInput) DescribeMultiplexProgramRequest {
	op := &aws.Operation{
		Name:       opDescribeMultiplexProgram,
		HTTPMethod: "GET",
		HTTPPath:   "/prod/multiplexes/{multiplexId}/programs/{programName}",
	}

	if input == nil {
		input = &DescribeMultiplexProgramInput{}
	}

	req := c.newRequest(op, input, &DescribeMultiplexProgramOutput{})

	return DescribeMultiplexProgramRequest{Request: req, Input: input, Copy: c.DescribeMultiplexProgramRequest}
}

// DescribeMultiplexProgramRequest is the request type for the
// DescribeMultiplexProgram API operation.
type DescribeMultiplexProgramRequest struct {
	*aws.Request
	Input *DescribeMultiplexProgramInput
	Copy  func(*DescribeMultiplexProgramInput) DescribeMultiplexProgramRequest
}

// Send marshals and sends the DescribeMultiplexProgram API request.
func (r DescribeMultiplexProgramRequest) Send(ctx context.Context) (*DescribeMultiplexProgramResponse, error) {
	r.Request.SetContext(ctx)
	err := r.Request.Send()
	if err != nil {
		return nil, err
	}

	resp := &DescribeMultiplexProgramResponse{
		DescribeMultiplexProgramOutput: r.Request.Data.(*DescribeMultiplexProgramOutput),
		response:                       &aws.Response{Request: r.Request},
	}

	return resp, nil
}

// DescribeMultiplexProgramResponse is the response type for the
// DescribeMultiplexProgram API operation.
type DescribeMultiplexProgramResponse struct {
	*DescribeMultiplexProgramOutput

	response *aws.Response
}

// SDKResponseMetdata returns the response metadata for the
// DescribeMultiplexProgram request.
func (r *DescribeMultiplexProgramResponse) SDKResponseMetdata() *aws.Response {
	return r.response
}
