// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package pinpoint

import (
	"context"

	"github.com/aws/aws-sdk-go-v2-0.24/aws"
	"github.com/aws/aws-sdk-go-v2-0.24/internal/awsutil"
	"github.com/aws/aws-sdk-go-v2-0.24/private/protocol"
)

type PutEventStreamInput struct {
	_ struct{} `type:"structure" payload:"WriteEventStream"`

	// ApplicationId is a required field
	ApplicationId *string `location:"uri" locationName:"application-id" type:"string" required:"true"`

	// Specifies the Amazon Resource Name (ARN) of an event stream to publish events
	// to and the AWS Identity and Access Management (IAM) role to use when publishing
	// those events.
	//
	// WriteEventStream is a required field
	WriteEventStream *WriteEventStream `type:"structure" required:"true"`
}

// String returns the string representation
func (s PutEventStreamInput) String() string {
	return awsutil.Prettify(s)
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *PutEventStreamInput) Validate() error {
	invalidParams := aws.ErrInvalidParams{Context: "PutEventStreamInput"}

	if s.ApplicationId == nil {
		invalidParams.Add(aws.NewErrParamRequired("ApplicationId"))
	}

	if s.WriteEventStream == nil {
		invalidParams.Add(aws.NewErrParamRequired("WriteEventStream"))
	}
	if s.WriteEventStream != nil {
		if err := s.WriteEventStream.Validate(); err != nil {
			invalidParams.AddNested("WriteEventStream", err.(aws.ErrInvalidParams))
		}
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// MarshalFields encodes the AWS API shape using the passed in protocol encoder.
func (s PutEventStreamInput) MarshalFields(e protocol.FieldEncoder) error {
	e.SetValue(protocol.HeaderTarget, "Content-Type", protocol.StringValue("application/json"), protocol.Metadata{})

	if s.ApplicationId != nil {
		v := *s.ApplicationId

		metadata := protocol.Metadata{}
		e.SetValue(protocol.PathTarget, "application-id", protocol.QuotedValue{ValueMarshaler: protocol.StringValue(v)}, metadata)
	}
	if s.WriteEventStream != nil {
		v := s.WriteEventStream

		metadata := protocol.Metadata{}
		e.SetFields(protocol.PayloadTarget, "WriteEventStream", v, metadata)
	}
	return nil
}

type PutEventStreamOutput struct {
	_ struct{} `type:"structure" payload:"EventStream"`

	// Specifies settings for publishing event data to an Amazon Kinesis data stream
	// or an Amazon Kinesis Data Firehose delivery stream.
	//
	// EventStream is a required field
	EventStream *EventStream `type:"structure" required:"true"`
}

// String returns the string representation
func (s PutEventStreamOutput) String() string {
	return awsutil.Prettify(s)
}

// MarshalFields encodes the AWS API shape using the passed in protocol encoder.
func (s PutEventStreamOutput) MarshalFields(e protocol.FieldEncoder) error {
	if s.EventStream != nil {
		v := s.EventStream

		metadata := protocol.Metadata{}
		e.SetFields(protocol.PayloadTarget, "EventStream", v, metadata)
	}
	return nil
}

const opPutEventStream = "PutEventStream"

// PutEventStreamRequest returns a request value for making API operation for
// Amazon Pinpoint.
//
// Creates a new event stream for an application or updates the settings of
// an existing event stream for an application.
//
//    // Example sending a request using PutEventStreamRequest.
//    req := client.PutEventStreamRequest(params)
//    resp, err := req.Send(context.TODO())
//    if err == nil {
//        fmt.Println(resp)
//    }
//
// Please also see https://docs.aws.amazon.com/goto/WebAPI/pinpoint-2016-12-01/PutEventStream
func (c *Client) PutEventStreamRequest(input *PutEventStreamInput) PutEventStreamRequest {
	op := &aws.Operation{
		Name:       opPutEventStream,
		HTTPMethod: "POST",
		HTTPPath:   "/v1/apps/{application-id}/eventstream",
	}

	if input == nil {
		input = &PutEventStreamInput{}
	}

	req := c.newRequest(op, input, &PutEventStreamOutput{})

	return PutEventStreamRequest{Request: req, Input: input, Copy: c.PutEventStreamRequest}
}

// PutEventStreamRequest is the request type for the
// PutEventStream API operation.
type PutEventStreamRequest struct {
	*aws.Request
	Input *PutEventStreamInput
	Copy  func(*PutEventStreamInput) PutEventStreamRequest
}

// Send marshals and sends the PutEventStream API request.
func (r PutEventStreamRequest) Send(ctx context.Context) (*PutEventStreamResponse, error) {
	r.Request.SetContext(ctx)
	err := r.Request.Send()
	if err != nil {
		return nil, err
	}

	resp := &PutEventStreamResponse{
		PutEventStreamOutput: r.Request.Data.(*PutEventStreamOutput),
		response:             &aws.Response{Request: r.Request},
	}

	return resp, nil
}

// PutEventStreamResponse is the response type for the
// PutEventStream API operation.
type PutEventStreamResponse struct {
	*PutEventStreamOutput

	response *aws.Response
}

// SDKResponseMetdata returns the response metadata for the
// PutEventStream request.
func (r *PutEventStreamResponse) SDKResponseMetdata() *aws.Response {
	return r.response
}
