// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package s3controliface provides an interface to enable mocking the AWS S3 Control service client
// for testing your code.
//
// It is important to note that this interface will have breaking changes
// when the service model is updated and adds new API operations, paginators,
// and waiters.
package s3controliface

import (
	"github.com/aws/aws-sdk-go-v2-0.24/service/s3control"
)

// ClientAPI provides an interface to enable mocking the
// s3control.Client methods. This make unit testing your code that
// calls out to the SDK's service client's calls easier.
//
// The best way to use this interface is so the SDK's service client's calls
// can be stubbed out for unit testing your code with the SDK without needing
// to inject custom request handlers into the SDK's request pipeline.
//
//    // myFunc uses an SDK service client to make a request to
//    // AWS S3 Control.
//    func myFunc(svc s3controliface.ClientAPI) bool {
//        // Make svc.CreateAccessPoint request
//    }
//
//    func main() {
//        cfg, err := external.LoadDefaultAWSConfig()
//        if err != nil {
//            panic("failed to load config, " + err.Error())
//        }
//
//        svc := s3control.New(cfg)
//
//        myFunc(svc)
//    }
//
// In your _test.go file:
//
//    // Define a mock struct to be used in your unit tests of myFunc.
//    type mockClientClient struct {
//        s3controliface.ClientPI
//    }
//    func (m *mockClientClient) CreateAccessPoint(input *s3control.CreateAccessPointInput) (*s3control.CreateAccessPointOutput, error) {
//        // mock response/functionality
//    }
//
//    func TestMyFunc(t *testing.T) {
//        // Setup Test
//        mockSvc := &mockClientClient{}
//
//        myfunc(mockSvc)
//
//        // Verify myFunc's functionality
//    }
//
// It is important to note that this interface will have breaking changes
// when the service model is updated and adds new API operations, paginators,
// and waiters. Its suggested to use the pattern above for testing, or using
// tooling to generate mocks to satisfy the interfaces.
type ClientAPI interface {
	CreateAccessPointRequest(*s3control.CreateAccessPointInput) s3control.CreateAccessPointRequest

	CreateJobRequest(*s3control.CreateJobInput) s3control.CreateJobRequest

	DeleteAccessPointRequest(*s3control.DeleteAccessPointInput) s3control.DeleteAccessPointRequest

	DeleteAccessPointPolicyRequest(*s3control.DeleteAccessPointPolicyInput) s3control.DeleteAccessPointPolicyRequest

	DeleteJobTaggingRequest(*s3control.DeleteJobTaggingInput) s3control.DeleteJobTaggingRequest

	DeletePublicAccessBlockRequest(*s3control.DeletePublicAccessBlockInput) s3control.DeletePublicAccessBlockRequest

	DescribeJobRequest(*s3control.DescribeJobInput) s3control.DescribeJobRequest

	GetAccessPointRequest(*s3control.GetAccessPointInput) s3control.GetAccessPointRequest

	GetAccessPointPolicyRequest(*s3control.GetAccessPointPolicyInput) s3control.GetAccessPointPolicyRequest

	GetAccessPointPolicyStatusRequest(*s3control.GetAccessPointPolicyStatusInput) s3control.GetAccessPointPolicyStatusRequest

	GetJobTaggingRequest(*s3control.GetJobTaggingInput) s3control.GetJobTaggingRequest

	GetPublicAccessBlockRequest(*s3control.GetPublicAccessBlockInput) s3control.GetPublicAccessBlockRequest

	ListAccessPointsRequest(*s3control.ListAccessPointsInput) s3control.ListAccessPointsRequest

	ListJobsRequest(*s3control.ListJobsInput) s3control.ListJobsRequest

	PutAccessPointPolicyRequest(*s3control.PutAccessPointPolicyInput) s3control.PutAccessPointPolicyRequest

	PutJobTaggingRequest(*s3control.PutJobTaggingInput) s3control.PutJobTaggingRequest

	PutPublicAccessBlockRequest(*s3control.PutPublicAccessBlockInput) s3control.PutPublicAccessBlockRequest

	UpdateJobPriorityRequest(*s3control.UpdateJobPriorityInput) s3control.UpdateJobPriorityRequest

	UpdateJobStatusRequest(*s3control.UpdateJobStatusInput) s3control.UpdateJobStatusRequest
}

var _ ClientAPI = (*s3control.Client)(nil)
