// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package shield

import (
	"context"

	"github.com/aws/aws-sdk-go-v2-0.24/aws"
	"github.com/aws/aws-sdk-go-v2-0.24/internal/awsutil"
)

type DisableProactiveEngagementInput struct {
	_ struct{} `type:"structure"`
}

// String returns the string representation
func (s DisableProactiveEngagementInput) String() string {
	return awsutil.Prettify(s)
}

type DisableProactiveEngagementOutput struct {
	_ struct{} `type:"structure"`
}

// String returns the string representation
func (s DisableProactiveEngagementOutput) String() string {
	return awsutil.Prettify(s)
}

const opDisableProactiveEngagement = "DisableProactiveEngagement"

// DisableProactiveEngagementRequest returns a request value for making API operation for
// AWS Shield.
//
// Removes authorization from the DDoS Response Team (DRT) to notify contacts
// about escalations to the DRT and to initiate proactive customer support.
//
//    // Example sending a request using DisableProactiveEngagementRequest.
//    req := client.DisableProactiveEngagementRequest(params)
//    resp, err := req.Send(context.TODO())
//    if err == nil {
//        fmt.Println(resp)
//    }
//
// Please also see https://docs.aws.amazon.com/goto/WebAPI/shield-2016-06-02/DisableProactiveEngagement
func (c *Client) DisableProactiveEngagementRequest(input *DisableProactiveEngagementInput) DisableProactiveEngagementRequest {
	op := &aws.Operation{
		Name:       opDisableProactiveEngagement,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &DisableProactiveEngagementInput{}
	}

	req := c.newRequest(op, input, &DisableProactiveEngagementOutput{})

	return DisableProactiveEngagementRequest{Request: req, Input: input, Copy: c.DisableProactiveEngagementRequest}
}

// DisableProactiveEngagementRequest is the request type for the
// DisableProactiveEngagement API operation.
type DisableProactiveEngagementRequest struct {
	*aws.Request
	Input *DisableProactiveEngagementInput
	Copy  func(*DisableProactiveEngagementInput) DisableProactiveEngagementRequest
}

// Send marshals and sends the DisableProactiveEngagement API request.
func (r DisableProactiveEngagementRequest) Send(ctx context.Context) (*DisableProactiveEngagementResponse, error) {
	r.Request.SetContext(ctx)
	err := r.Request.Send()
	if err != nil {
		return nil, err
	}

	resp := &DisableProactiveEngagementResponse{
		DisableProactiveEngagementOutput: r.Request.Data.(*DisableProactiveEngagementOutput),
		response:                         &aws.Response{Request: r.Request},
	}

	return resp, nil
}

// DisableProactiveEngagementResponse is the response type for the
// DisableProactiveEngagement API operation.
type DisableProactiveEngagementResponse struct {
	*DisableProactiveEngagementOutput

	response *aws.Response
}

// SDKResponseMetdata returns the response metadata for the
// DisableProactiveEngagement request.
func (r *DisableProactiveEngagementResponse) SDKResponseMetdata() *aws.Response {
	return r.response
}
