// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package worklink

import (
	"context"

	"github.com/aws/aws-sdk-go-v2-0.24/aws"
	"github.com/aws/aws-sdk-go-v2-0.24/internal/awsutil"
	"github.com/aws/aws-sdk-go-v2-0.24/private/protocol"
)

type ListWebsiteCertificateAuthoritiesInput struct {
	_ struct{} `type:"structure"`

	// The ARN of the fleet.
	//
	// FleetArn is a required field
	FleetArn *string `min:"20" type:"string" required:"true"`

	// The maximum number of results to be included in the next page.
	MaxResults *int64 `min:"1" type:"integer"`

	// The pagination token used to retrieve the next page of results for this operation.
	// If this value is null, it retrieves the first page.
	NextToken *string `min:"1" type:"string"`
}

// String returns the string representation
func (s ListWebsiteCertificateAuthoritiesInput) String() string {
	return awsutil.Prettify(s)
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *ListWebsiteCertificateAuthoritiesInput) Validate() error {
	invalidParams := aws.ErrInvalidParams{Context: "ListWebsiteCertificateAuthoritiesInput"}

	if s.FleetArn == nil {
		invalidParams.Add(aws.NewErrParamRequired("FleetArn"))
	}
	if s.FleetArn != nil && len(*s.FleetArn) < 20 {
		invalidParams.Add(aws.NewErrParamMinLen("FleetArn", 20))
	}
	if s.MaxResults != nil && *s.MaxResults < 1 {
		invalidParams.Add(aws.NewErrParamMinValue("MaxResults", 1))
	}
	if s.NextToken != nil && len(*s.NextToken) < 1 {
		invalidParams.Add(aws.NewErrParamMinLen("NextToken", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// MarshalFields encodes the AWS API shape using the passed in protocol encoder.
func (s ListWebsiteCertificateAuthoritiesInput) MarshalFields(e protocol.FieldEncoder) error {
	e.SetValue(protocol.HeaderTarget, "Content-Type", protocol.StringValue("application/json"), protocol.Metadata{})

	if s.FleetArn != nil {
		v := *s.FleetArn

		metadata := protocol.Metadata{}
		e.SetValue(protocol.BodyTarget, "FleetArn", protocol.QuotedValue{ValueMarshaler: protocol.StringValue(v)}, metadata)
	}
	if s.MaxResults != nil {
		v := *s.MaxResults

		metadata := protocol.Metadata{}
		e.SetValue(protocol.BodyTarget, "MaxResults", protocol.Int64Value(v), metadata)
	}
	if s.NextToken != nil {
		v := *s.NextToken

		metadata := protocol.Metadata{}
		e.SetValue(protocol.BodyTarget, "NextToken", protocol.QuotedValue{ValueMarshaler: protocol.StringValue(v)}, metadata)
	}
	return nil
}

type ListWebsiteCertificateAuthoritiesOutput struct {
	_ struct{} `type:"structure"`

	// The pagination token used to retrieve the next page of results for this operation.
	// If there are no more pages, this value is null.
	NextToken *string `min:"1" type:"string"`

	// Information about the certificates.
	WebsiteCertificateAuthorities []WebsiteCaSummary `type:"list"`
}

// String returns the string representation
func (s ListWebsiteCertificateAuthoritiesOutput) String() string {
	return awsutil.Prettify(s)
}

// MarshalFields encodes the AWS API shape using the passed in protocol encoder.
func (s ListWebsiteCertificateAuthoritiesOutput) MarshalFields(e protocol.FieldEncoder) error {
	if s.NextToken != nil {
		v := *s.NextToken

		metadata := protocol.Metadata{}
		e.SetValue(protocol.BodyTarget, "NextToken", protocol.QuotedValue{ValueMarshaler: protocol.StringValue(v)}, metadata)
	}
	if s.WebsiteCertificateAuthorities != nil {
		v := s.WebsiteCertificateAuthorities

		metadata := protocol.Metadata{}
		ls0 := e.List(protocol.BodyTarget, "WebsiteCertificateAuthorities", metadata)
		ls0.Start()
		for _, v1 := range v {
			ls0.ListAddFields(v1)
		}
		ls0.End()

	}
	return nil
}

const opListWebsiteCertificateAuthorities = "ListWebsiteCertificateAuthorities"

// ListWebsiteCertificateAuthoritiesRequest returns a request value for making API operation for
// Amazon WorkLink.
//
// Retrieves a list of certificate authorities added for the current account
// and Region.
//
//    // Example sending a request using ListWebsiteCertificateAuthoritiesRequest.
//    req := client.ListWebsiteCertificateAuthoritiesRequest(params)
//    resp, err := req.Send(context.TODO())
//    if err == nil {
//        fmt.Println(resp)
//    }
//
// Please also see https://docs.aws.amazon.com/goto/WebAPI/worklink-2018-09-25/ListWebsiteCertificateAuthorities
func (c *Client) ListWebsiteCertificateAuthoritiesRequest(input *ListWebsiteCertificateAuthoritiesInput) ListWebsiteCertificateAuthoritiesRequest {
	op := &aws.Operation{
		Name:       opListWebsiteCertificateAuthorities,
		HTTPMethod: "POST",
		HTTPPath:   "/listWebsiteCertificateAuthorities",
		Paginator: &aws.Paginator{
			InputTokens:     []string{"NextToken"},
			OutputTokens:    []string{"NextToken"},
			LimitToken:      "MaxResults",
			TruncationToken: "",
		},
	}

	if input == nil {
		input = &ListWebsiteCertificateAuthoritiesInput{}
	}

	req := c.newRequest(op, input, &ListWebsiteCertificateAuthoritiesOutput{})

	return ListWebsiteCertificateAuthoritiesRequest{Request: req, Input: input, Copy: c.ListWebsiteCertificateAuthoritiesRequest}
}

// ListWebsiteCertificateAuthoritiesRequest is the request type for the
// ListWebsiteCertificateAuthorities API operation.
type ListWebsiteCertificateAuthoritiesRequest struct {
	*aws.Request
	Input *ListWebsiteCertificateAuthoritiesInput
	Copy  func(*ListWebsiteCertificateAuthoritiesInput) ListWebsiteCertificateAuthoritiesRequest
}

// Send marshals and sends the ListWebsiteCertificateAuthorities API request.
func (r ListWebsiteCertificateAuthoritiesRequest) Send(ctx context.Context) (*ListWebsiteCertificateAuthoritiesResponse, error) {
	r.Request.SetContext(ctx)
	err := r.Request.Send()
	if err != nil {
		return nil, err
	}

	resp := &ListWebsiteCertificateAuthoritiesResponse{
		ListWebsiteCertificateAuthoritiesOutput: r.Request.Data.(*ListWebsiteCertificateAuthoritiesOutput),
		response:                                &aws.Response{Request: r.Request},
	}

	return resp, nil
}

// NewListWebsiteCertificateAuthoritiesRequestPaginator returns a paginator for ListWebsiteCertificateAuthorities.
// Use Next method to get the next page, and CurrentPage to get the current
// response page from the paginator. Next will return false, if there are
// no more pages, or an error was encountered.
//
// Note: This operation can generate multiple requests to a service.
//
//   // Example iterating over pages.
//   req := client.ListWebsiteCertificateAuthoritiesRequest(input)
//   p := worklink.NewListWebsiteCertificateAuthoritiesRequestPaginator(req)
//
//   for p.Next(context.TODO()) {
//       page := p.CurrentPage()
//   }
//
//   if err := p.Err(); err != nil {
//       return err
//   }
//
func NewListWebsiteCertificateAuthoritiesPaginator(req ListWebsiteCertificateAuthoritiesRequest) ListWebsiteCertificateAuthoritiesPaginator {
	return ListWebsiteCertificateAuthoritiesPaginator{
		Pager: aws.Pager{
			NewRequest: func(ctx context.Context) (*aws.Request, error) {
				var inCpy *ListWebsiteCertificateAuthoritiesInput
				if req.Input != nil {
					tmp := *req.Input
					inCpy = &tmp
				}

				newReq := req.Copy(inCpy)
				newReq.SetContext(ctx)
				return newReq.Request, nil
			},
		},
	}
}

// ListWebsiteCertificateAuthoritiesPaginator is used to paginate the request. This can be done by
// calling Next and CurrentPage.
type ListWebsiteCertificateAuthoritiesPaginator struct {
	aws.Pager
}

func (p *ListWebsiteCertificateAuthoritiesPaginator) CurrentPage() *ListWebsiteCertificateAuthoritiesOutput {
	return p.Pager.CurrentPage().(*ListWebsiteCertificateAuthoritiesOutput)
}

// ListWebsiteCertificateAuthoritiesResponse is the response type for the
// ListWebsiteCertificateAuthorities API operation.
type ListWebsiteCertificateAuthoritiesResponse struct {
	*ListWebsiteCertificateAuthoritiesOutput

	response *aws.Response
}

// SDKResponseMetdata returns the response metadata for the
// ListWebsiteCertificateAuthorities request.
func (r *ListWebsiteCertificateAuthoritiesResponse) SDKResponseMetdata() *aws.Response {
	return r.response
}
